/*
  作成者: ihara789
  作成日: 2023/12/01
  更新日: 2023/12/14
*/

// --------------------------------------------

// filed
var playfield_width = 600;
var playfield_height = 400;
var playfield_color = '#2c4f54'

// ball
// var ball_start_x = 100;
// var ball_start_y = 200;
var ball_color = '#fff352'

const balls = [
    { enable: true, size: 5, x: 400, y: 100, id: 1 },
];

// other configuration
var frame_duration = 10;
var speed_x = 2;
var speed_y = 1;
var gravity = 0.05;

// Field
const canvas = document.querySelector('#playfield');
class Playfield {
    constructor(canvas, x, y, width, height, color) {
        this.canvas = canvas;
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
        this.canvas.width = playfield_width;
        this.canvas.height = playfield_height;
    }
    draw() {
        const ctx = this.canvas.getContext('2d');
        ctx.fillStyle = this.color;
        ctx.fillRect(this.x, this.y, this.width, this.height);
    }
}

// Ball
class Ball {
    constructor(id) {
        this.canvas = canvas;
        this.ball_color = ball_color;

        // target_ball
        // -------------- ballsの値でボールを描画 -------------- 
        var ball_current = balls.find((ball) => ball.id === id);
        this.ball_current_id = ball_current.id;
        this.ball_current_enable = ball_current.enable;
        var ball_current_size = ball_current.size;
        this.x = ball_current.x;
        this.y = ball_current.y;
        this.radius = ball_current_size * 10;
    }
    draw() {
        // draw -------------- 
        const ctx = this.canvas.getContext('2d');
        ctx.fillStyle = this.ball_color;
        ctx.beginPath();
        ctx.arc(this.x, this.y, this.radius, 0, Math.PI * 2);
        ctx.fill();

        // move -------------- 
        const ball_point = balls.find((ball) => ball.id === this.ball_current_id);
        if (playfield_width - this.x - this.radius <= 0 && 0 <= speed_x ||
            this.x - this.radius <= 0 && speed_x < 0) {
            speed_x = -speed_x;
        }
        if (playfield_height - this.y - this.radius <= 0 && 0 <= speed_y ||
            this.y - this.radius <= 0 && speed_y < 0) {
            speed_y = -speed_y;
        }
        balls.find((ball) => ball.id === this.ball_current_id).x = ball_point.x + speed_x;
        balls.find((ball) => ball.id === this.ball_current_id).y += speed_y;
        speed_y += gravity;
        balls.find((ball) => ball.id === this.ball_current_id).y = ball_point.y + speed_y;
    }
}

// Field | Rendering
const playfield = new Playfield(canvas, 0, 0, playfield_width, playfield_height, playfield_color);
playfield.draw();

const ballsByID = {};
const interval = setInterval(() => {
    playfield.draw();
    for (const ball of balls) {
        if (ball.enable === true) {
            ballsByID[ball.id] = new Ball(ball.id);
            ballsByID[ball.id].draw();
        }
    }
}, frame_duration);
